using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Threading;
using System.Threading.Tasks;

namespace Props.Shop.Framework
{
    public interface IShop : IDisposable
    {
        string ShopName { get; }
        string ShopDescription { get; }
        string ShopModuleAuthor { get; }

        public IAsyncEnumerable<ProductListing> Search(string query, Filters filters);

        IEnumerable<IOption> Initialize(byte[] data);
        public SupportedFeatures SupportedFeatures { get; }
        public byte[] GetDataForPersistence();
    }
}